import de.berlios.tulklut.*;
import java.io.*;

/*
 * Classe réalisant une application en ligne de commande pour traduire du texte
 * en bulgroz.
 * @author Michel PETIT (pemichel@wanadoo.fr)
 * @version 1.0
 * @date 2006/09/24
 * @todo Ajouter une méthode permettant de prendre du flux de texte redirigé en
 * entré
 */
class TulklutCli {

  private static String NAME    = "TulklutCli"; //!< Nom du programme
  private static String VERSION = "1.0";        //!< Version du programme

  /**
   * Message d'aide du programme
   */
  private static String HELP    =
    "\njava TulklutCli [param]\njava TulklutCli [\"String\"]\n\n" +
    "  -v, --version:   Display version number\n" +
    "  -c, --copyright: Display copyright information\n" +
    "  -h, --help:      Display this short help message\n" +
    "  \"String\":      String to translate into bulgroz language\n\n";
  private static String COPYRIGHT =
  "Copyright © 2006 Michel PETIT\n" +
  "Ce programme est un logiciel libre ; vous pouvez en redistribuer des copies"+
  " selon les termes de la License Publique Générale GNU "+
  "<http://www.gnu.org/licenses/gpl.html>.\n"+
  "il n'y a AUCUNE GARANTIE, jusqu'au point permis par la loi.\n\n"+
  "Écrit par Torbjorn Granlund et Richard M. Stallman.";
  
  public void TulklutCli() {
  }

  /**
   * Affiche sur la sortie standard la version du programme ainsi que son nom.
   */
  public static void version(){
    System.out.println("\n" + TulklutCli.NAME +" "+ TulklutCli.VERSION +"\n\n");
    System.exit(0);
  }

  /**
   * Affiche le message d'aide sur la sortie standard pour expliquer la façon
   * d'utiliser le programme.
   */
  public static void help(){
    System.out.println(TulklutCli.HELP);
    System.exit(0);
  }

  /**
   * Affiche les informations sur le droit de copie
   */
  public static void copyright(){
    System.out.println("\n" + TulklutCli.NAME + " " + TulklutCli.COPYRIGHT);
    System.exit(0);
  }
  
  /**
   * Lance l'exécution du programme.
   * @param args Tableau contenant les options de la ligne de commande
   */
  public static void main(String[] args){
    TulklutCli tulklutCli = new TulklutCli();
    Bulgroz bulgroz;
    bulgroz  = new Bulgroz();
    int al   = args.length;
    String s = new String();
    
    switch(al){
      case 0:
        try {
          Reader in = new InputStreamReader(System.in);
          for(;;){
            int c = in.read();
            if(c == -1) break;
            s = s + (char)c;
          }
          bulgroz.setInputString(s);
          System.out.println(bulgroz.getOutputString());
        } catch(IOException ioe){
          System.err.print("\nErreur de traitement du flux !\n");
          System.exit(2);
        }    
        break;
   
      case 1:
        if(args[0].equals("-h"))          TulklutCli.help();
        if(args[0].equals("--help"))      TulklutCli.help();
        if(args[0].equals("-v"))          TulklutCli.version();
        if(args[0].equals("--version"))   TulklutCli.version();
        if(args[0].equals("-c"))          TulklutCli.copyright();
        if(args[0].equals("--copyright")) TulklutCli.copyright();
        bulgroz.setInputString(args[0]);
        System.out.println(bulgroz.getOutputString());
        break;
    
      default:
        TulklutCli.help();
        break;
    }
  }
}
